/* device driver for dio dio card */
/* these defs are available to user programs */

/* ioctl numbers - arbitrary number here
 * consult Documentation/magic-number.txt
 * if you want to make a more informed choice !
 */

/* Minor dev numbers, 0->binary access 1,2,4 ports 0,1,2 1+2+4=allports */
#define MINOR_BIN	0

#ifdef DIO_DEBUG
#define PRINT_DEBUG(a,args...)	printk(a,## args);
#else 
#define PRINT_DEBUG(a,args...)
#endif


#define DIO_MOD_NAME		"dio"

/* following are the factory defaults for the DIO */
/* They are all acceptable for webface- matt aug 2001*/
#define DIO_VENDOR	0x1230
#define DIO_DEVICE	0x0001
#define BOOL	char
#define TRUE	1
#define FALSE 	0
#define DIO_READ 	1
#define	DIO_WRITE	0

/* a fixed text buffer > sizeof("12345678 12345678 12345678"); */


#define DIO_IO_REGION_SIZE	64*1024 /*64k space */
#define DIO_WORD_SIZE		4
#define DIO_CNTL		0xc000
#define DIO_IO_PORT_0		0x8000
#define DIO_IO_PORT_1		0x8010
#define DIO_IO_PORT_2		0x8020
#define DIO_NO_DIO_PORTS	3	
#define DIO_NO_DIO_BYTES	DIO_NO_DIO_PORTS*DIO_WORD_SIZE
/* first 12 out of 32 bits =FFF bits 1-12 r/w mask, 13 latch, 14 reserved */
/* in the 1st 12 bits a 1 indicates output and 0 input */
#define DIO_CNTL_PORT_MASK	0x00008FFF
#define DIO_CNTL_LATCH_MASK	0x00008000
#define DIO_CNTRL_TEST_MASK	0x00004000
#define DIO_DIR_MASK		0x00000FFF

#define DIO_BUFF_SIZE		512
#define DIO_USECS_PER_HZ        1000000/HZ

static u32 dio_dir;
static u32 dio_latch=FALSE;

/* driver globals */
static void * dio_base=NULL;
static void * dio_cntl=NULL; 



static unsigned long dio_read_seq=0,dio_write_seq=0;
static int dio_read_n=0,dio_write_n=0,dio_delay_time=0;
