#include <stdio.h>
#include <stdlib.h>
#include <linux/types.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include "dio_interface.h"

#define DIO_NAME "/dev/dio"

int trans[]={DIO_READ_0,DIO_READ_1,DIO_READ_2};
void    tic(void);
float   toc(void);
inline double tosec(struct timeval);
struct timeval  t_now,t_then;
#define N 1000000
#define M 2
main(int argc,char **argv){
int dev;
int port;
unsigned int val;
float t;
int i;
int ret;
__u32 buffer[M*sizeof(__u32)];

	dev=open(DIO_NAME,O_RDWR);
	if(dev<0){
		printf("Error: could not open %s\n",DIO_NAME);
		exit(0);
		}
	tic();
	printf("About to perform %d reads in chunks of %d\n",N,M);
	ret=ioctl(dev,DIO_WRITE_SEQ,DIO_PORT_1|DIO_PORT_2);
	printf("DIO_WRITE_SEQ returned %d reads\n",ret);
	for(i=0;i<(N);){
		ret=write(dev,buffer,M*sizeof(__u32));
		if(ret<0){
			printf("Got an invalid return\n");
			exit(0);
			}
		i+=ret;
		}
	t=toc();
	printf("That took %.02fs for %d writes\n",t,i);
	printf("Rate= %.2f Mwps\n",i/t/1000000);
	close(dev);
	printf("%x\n",buffer[0]);
	}



void tic(void){
        gettimeofday(&t_then,NULL);
        //return tosec(t_then);
        }

float toc(void){
        gettimeofday(&t_now,NULL);
        return tosec(t_now)-tosec(t_then);
        }
inline double tosec(struct timeval temp){
double  t;
        t=(double)temp.tv_sec+(double)temp.tv_usec/1000000.0;
        return t;
        }

